diff --git a/etc/dosemu.conf b/etc/dosemu.conf
index 4cabe08414..9d19575ac1 100644
--- a/etc/dosemu.conf
+++ b/etc/dosemu.conf
@@ -235,8 +235,14 @@
 # $_dosmem = (640)
 
 # Extended Memory size. This memory is accessible via int15h and can be
-# used by himem.sys and the internal XMS driver.
-# Default: 8192
+# used by himem.sys.
+# Default: 4096 (4Mb)
+
+# $_ext_mem = (4096)
+
+# XMS (internal driver) is only needed if you do not load
+# himem.sys or another external XMS driver. Size in Kbytes.
+# Default: 8192 (8Mb)
 
 # $_xms = (8192)
 
@@ -311,9 +317,9 @@
 # $_dpmi = (0x20000)
 
 # DPMI base address
-# Default: 0x800000
+# Default: 0x2000000 (at 32Mb)
 
-# $_dpmi_base = (0x800000)
+# $_dpmi_base = (0x2000000)
 
 # Size of reserved linear address space for DPMI.
 # Default: 0x80000 (reserve 512Mb)
diff --git a/etc/global.conf b/etc/global.conf
index 3281e7a0c9..2e7ad05a3a 100644
--- a/etc/global.conf
+++ b/etc/global.conf
@@ -139,11 +139,8 @@ else
   pm_dos_api 1
   ignore_djgpp_null_derefs $_ignore_djgpp_null_derefs
   dosmem $_dosmem
-  if ($_ext_mem)
-    ext_mem $_ext_mem
-  else
-    ext_mem $_xms
-  endif
+  ext_mem $_ext_mem
+  xms $_xms
 
   if ($_emusys ne "") emusys $_emusys endif
 
diff --git a/src/arch/linux/mapping/mapfile.c b/src/arch/linux/mapping/mapfile.c
index 978bb68d2f..5bbdddaf76 100644
--- a/src/arch/linux/mapping/mapfile.c
+++ b/src/arch/linux/mapping/mapfile.c
@@ -94,6 +94,7 @@ static int open_mapping_f(int cap)
  				/* VGAEMU */
     mapsize += config.vgaemu_memsize ? config.vgaemu_memsize : 1024;
     mapsize += config.ems_size;	/* EMS */
+    mapsize += config.xms_size;	/* XMS */
     mapsize += LOWMEM_SIZE >> 10; /* Low Mem */
     estsize = mapsize;
 				/* keep heap fragmentation in mind */
diff --git a/src/base/core/int.c b/src/base/core/int.c
index 2889c1ff06..bc5c4dcae3 100644
--- a/src/base/core/int.c
+++ b/src/base/core/int.c
@@ -923,10 +923,7 @@ static int int15(void)
 	}
 
     case 0x88:
-	if (xms_intdrv())
-	    LWORD(eax) = 0;
-	else
-	    LWORD(eax) = (EXTMEM_SIZE + HMASIZE) >> 10;
+	LWORD(eax) = (EXTMEM_SIZE + HMASIZE) >> 10;
 	NOCARRY;
 	break;
 
diff --git a/src/base/init/init.c b/src/base/init/init.c
index f8758244e5..f082720483 100644
--- a/src/base/init/init.c
+++ b/src/base/init/init.c
@@ -45,6 +45,7 @@
 #define GFX_CHARS       0xffa6e
 
 smpool main_pool;
+smpool lin_pool;
 
 #if 0
 static inline void dbug_dumpivec(void)
@@ -328,6 +329,7 @@ void low_mem_init(void)
   int result;
   uint32_t memsize = LOWMEM_SIZE + HMASIZE;
   uint32_t dpmi_size = dpmi_lin_mem_rsv();
+  int32_t dpmi_rsv_low = config.dpmi_base;
 
   open_mapping(MAPPING_INIT_LOWRAM);
   g_printf ("DOS+HMA memory area being mapped in\n");
@@ -351,8 +353,30 @@ void low_mem_init(void)
   sminit(&main_pool, mem_base, memsize + dpmi_size);
   ptr = smalloc(&main_pool, memsize);
   assert(ptr == mem_base);
+  dpmi_rsv_low -= memsize;
+  if (config.ext_mem) {
+    ptr = smalloc(&main_pool, EXTMEM_SIZE);
+    if (!ptr) {
+        error("failure to allocate ext mem\n");
+        config.exitearly = 1;
+        return;
+    }
+    x_printf("Ext.Mem of size 0x%x at %p\n", EXTMEM_SIZE, ext_mem_base);
+    memcheck_addtype('x', "Extended memory (HMA+XMS)");
+    memcheck_reserve('x', LOWMEM_SIZE + HMASIZE, EXTMEM_SIZE);
+    dpmi_rsv_low -= EXTMEM_SIZE;
+  }
+  if (dpmi_rsv_low <= 0) {
+    error("overlap between $_dpmi_base and $_ext_mem\n");
+    config.exitearly = 1;
+    return;
+  }
+  ptr = smalloc(&main_pool, dpmi_rsv_low);
+  assert(ptr);
+  sminit(&lin_pool, ptr, dpmi_rsv_low); // for fixed allocs of dpmi and xms
   if (config.dpmi) {
-    ptr = smalloc(&main_pool, dpmi_mem_size(ptr + memsize));
+    void *dpmi_base = smalloc(&main_pool, dpmi_mem_size());
+    assert(DOSADDR_REL(dpmi_base) == config.dpmi_base);
     dpmi_set_mem_base(ptr);
   }
 
diff --git a/src/base/init/parser.y b/src/base/init/parser.y
index 3678ca77ed..0676fb0416 100644
--- a/src/base/init/parser.y
+++ b/src/base/init/parser.y
@@ -643,6 +643,11 @@ line:		CHARSET '{' charset_flags '}' {}
 		| EXT_MEM int_bool
 		    {
 		    if ($2>=0) config.ext_mem = $2;
+		    if ($2 > 0) c_printf("CONF: %dk bytes int15 ext memory\n", $2);
+		    }
+		| L_XMS int_bool
+		    {
+		    if ($2>=0) config.xms_size = $2;
 		    if ($2 > 0) c_printf("CONF: %dk bytes XMS memory\n", $2);
 		    }
 		| MATHCO bool		{ config.mathco = ($2!=0); }
diff --git a/src/base/misc/hma.c b/src/base/misc/hma.c
index d4c1765949..082c8e308b 100644
--- a/src/base/misc/hma.c
+++ b/src/base/misc/hma.c
@@ -24,7 +24,6 @@
 
 #define HMAAREA 0x100000
 
-unsigned char *ext_mem_base = NULL;
 int a20;
 
 static void HMA_MAP(int HMA)
@@ -76,13 +75,8 @@ void HMA_init(void)
     return;
   }
   a20 = 0;
-  if (config.ext_mem) {
-    ext_mem_base = mmap_mapping(MAPPING_EXTMEM | MAPPING_SCRATCH, -1,
-      EXTMEM_SIZE, PROT_READ | PROT_WRITE);
-    x_printf("Ext.Mem of size 0x%x at %p\n", EXTMEM_SIZE, ext_mem_base);
-    memcheck_addtype('x', "Extended memory (HMA+XMS)");
-    memcheck_reserve('x', LOWMEM_SIZE, HMASIZE + EXTMEM_SIZE);
-  }
+  memcheck_addtype('H', "HMA");
+  memcheck_reserve('H', LOWMEM_SIZE, HMASIZE);
 }
 
 
diff --git a/src/dosext/dpmi/emudpmi.h b/src/dosext/dpmi/emudpmi.h
index 34e5ea4548..6789d6f023 100644
--- a/src/dosext/dpmi/emudpmi.h
+++ b/src/dosext/dpmi/emudpmi.h
@@ -239,7 +239,7 @@ void dpmi_init(void);
 extern unsigned short dpmi_sel(void);
 extern unsigned short dpmi_sel16(void);
 extern unsigned short dpmi_sel32(void);
-unsigned long dpmi_mem_size(void *rsv_base);
+unsigned long dpmi_mem_size(void);
 void dpmi_set_mem_base(void *rsv_base);
 void dump_maps(void);
 
@@ -346,7 +346,7 @@ static inline void dpmi_set_mem_base(void *rsv_base)
 {
 }
 
-static inline unsigned long dpmi_mem_size(void *rsv_base)
+static inline unsigned long dpmi_mem_size(void)
 {
     return 0;
 }
diff --git a/src/dosext/dpmi/memory.c b/src/dosext/dpmi/memory.c
index 7275cbc0de..43d6ed3aaf 100644
--- a/src/dosext/dpmi/memory.c
+++ b/src/dosext/dpmi/memory.c
@@ -48,7 +48,6 @@ static unsigned int mem_allocd;           /* how many bytes memory client */
 unsigned int pm_block_handle_used;       /* tracking handle */
 
 static smpool mem_pool;
-static smpool lin_pool;
 static void *dpmi_lin_rsv_base;
 static void *dpmi_base;
 static uint32_t low_rsv;
@@ -193,7 +192,7 @@ static int uncommit(void *ptr, size_t size)
   return 1;
 }
 
-static unsigned long _dpmi_mem_size(void)
+unsigned long dpmi_mem_size(void)
 {
     if (!config.dpmi)
 	return 0;
@@ -205,14 +204,6 @@ static unsigned long _dpmi_mem_size(void)
       (5 << PAGE_SHIFT); /* 5 extra pages */
 }
 
-unsigned long dpmi_mem_size(void *rsv_base)
-{
-    int rsv = MEM_BASE32(config.dpmi_base) - (unsigned char *)rsv_base;
-    if (!config.dpmi || rsv < 4096)
-	return 0;
-    return PAGE_ALIGN(_dpmi_mem_size() + rsv);
-}
-
 void dump_maps(void)
 {
     char buf[64];
@@ -238,7 +229,7 @@ int dpmi_lin_mem_free(void)
 
 int dpmi_alloc_pool(void)
 {
-    uint32_t memsize = _dpmi_mem_size();
+    uint32_t memsize = dpmi_mem_size();
 
     if (dpmi_base < dpmi_lin_rsv_base || dpmi_base + memsize >
 	    dpmi_lin_rsv_base + dpmi_lin_mem_rsv()) {
@@ -248,32 +239,18 @@ int dpmi_alloc_pool(void)
     c_printf("DPMI: mem init, mpool is %d bytes at %p\n", memsize, dpmi_base);
     /* Create DPMI pool */
     sminit_com(&mem_pool, dpmi_base, memsize, commit, uncommit);
-    sminit_com(&lin_pool, dpmi_lin_rsv_base, low_rsv, commit, uncommit);
     dpmi_total_memory = config.dpmi * 1024;
 
-    mprotect_mapping(MAPPING_DPMI, DOSADDR_REL(dpmi_lin_rsv_base),
-                memsize + low_rsv, PROT_NONE);
-    /* Elite First Encounters setup.exe insists on low reserve
-     * area being writable... */
-    if (config.no_null_checks) {
-        mprotect_mapping(MAPPING_DPMI, DOSADDR_REL(dpmi_lin_rsv_base),
-                low_rsv, PROT_READ | PROT_WRITE);
-    }
+    mprotect_mapping(MAPPING_DPMI, config.dpmi_base, memsize, PROT_NONE);
     D_printf("DPMI: dpmi_free_memory available 0x%x\n", dpmi_total_memory);
     return 0;
 }
 
 void dpmi_free_pool(void)
 {
-    uint32_t memsize = _dpmi_mem_size() + low_rsv;
     int leak = smdestroy(&mem_pool);
     if (leak)
 	error("DPMI: leaked %i bytes (main pool)\n", leak);
-    leak = smdestroy(&lin_pool);
-    if (leak)
-	error("DPMI: leaked %i bytes (lin pool)\n", leak);
-    mprotect_mapping(MAPPING_DPMI, DOSADDR_REL(dpmi_lin_rsv_base),
-                memsize, PROT_READ | PROT_WRITE);
 }
 
 static int SetAttribsForPage(unsigned int ptr, us attr, us *old_attr_p)
diff --git a/src/dosext/misc/xms.c b/src/dosext/misc/xms.c
index 012c8afd55..5a3485b62e 100644
--- a/src/dosext/misc/xms.c
+++ b/src/dosext/misc/xms.c
@@ -30,6 +30,7 @@
 #include "int.h"
 #include "hma.h"
 #include "emm.h"
+#include "mapping.h"
 #include "dos2linux.h"
 #include "cpu-emu.h"
 #include "smalloc.h"
@@ -67,11 +68,28 @@ static char RCSxms[] = "$Id$";
 
 static int a20_local, a20_global, freeHMA;	/* is HMA free? */
 
+struct __attribute__ ((__packed__)) EMM {
+   unsigned int Length;
+   unsigned short SourceHandle;
+   unsigned int SourceOffset;
+   unsigned short DestHandle;
+   unsigned int DestOffset;
+};
+
+struct Handle {
+  unsigned short int num;
+  void *addr;
+  unsigned int size;
+  int valid;
+  int lockcount;
+  dosaddr_t dst;
+};
+
 static struct Handle handles[NUM_HANDLES];
 static int handle_count;
 static int intdrv;
 static int ext_hooked_hma;
-static unsigned char *xms_base;
+static int totalBytes;
 
 void show_emm(struct EMM);
 static unsigned char xms_query_freemem(int), xms_allocate_EMB(int), xms_free_EMB(void),
@@ -206,28 +224,51 @@ umb_query(void)
 
 /* end of stuff from Mach */
 
-static smpool mp;
+static void *xms_alloc(unsigned size)
+{
+  void *ptr = alloc_mapping(MAPPING_OTHER, size);
+  if (ptr == MAP_FAILED)
+    return 0;
+  return ptr;
+}
 
-static unsigned xms_alloc(unsigned size)
+static void *xms_realloc(void *optr, unsigned osize, unsigned size)
 {
-  unsigned char *ptr = smalloc_aligned(&mp, PAGE_SIZE, size);
-  if (!ptr)
+  void *ptr = realloc_mapping(MAPPING_OTHER, optr, osize, size);
+  if (ptr == MAP_FAILED)
     return 0;
-  return ptr - xms_base;
+  return ptr;
+}
+
+static void xms_free(void *addr, unsigned osize)
+{
+  free_mapping(MAPPING_OTHER, addr, osize);
 }
 
-static unsigned xms_realloc(unsigned dosptr, unsigned size)
+static dosaddr_t map_EMB(void *addr, unsigned size)
 {
-  unsigned char *optr = &xms_base[dosptr];
-  unsigned char *ptr = smrealloc_aligned(&mp, optr, PAGE_SIZE, size);
-  if (!ptr)
+  int err;
+  void *ptr = smalloc_aligned(&lin_pool, PAGE_SIZE, size);
+  dosaddr_t ret;
+  if (!ptr) {
+    error("error allocating %i bytes for xms\n", size);
     return 0;
-  return ptr - xms_base;
+  }
+  ret = DOSADDR_REL(ptr);
+  err = alias_mapping(MAPPING_OTHER, ret, size, PROT_READ | PROT_WRITE, addr);
+  if (err) {
+    error("error mapping %p to %x for xms\n", addr, ret);
+    return 0;
+  }
+  return ret;
 }
 
-static void xms_free(unsigned addr)
+static void unmap_EMB(dosaddr_t base, unsigned size)
 {
-  smfree(&mp, &xms_base[addr]);
+  /* don't unmap, just overmap with scratch page */
+  mmap_mapping(MAPPING_OTHER | MAPPING_SCRATCH, base, size,
+        PROT_READ | PROT_WRITE);
+  smfree(&lin_pool, MEM_BASE32(base));
 }
 
 void
@@ -237,7 +278,6 @@ xms_reset(void)
     umb_free_all();
     memcheck_map_free('U');
   }
-  config.xms_size = 0;
   intdrv = 0;
   freeHMA = 0;
   ext_hooked_hma = 0;
@@ -245,7 +285,6 @@ xms_reset(void)
 
 static void xms_local_reset(void)
 {
-  config.xms_size = 0;
   intdrv = 0;
 }
 
@@ -268,9 +307,7 @@ static int xms_helper_init(void)
 
   if (intdrv)
     return 1;
-  intdrv = 1;
 
-  config.xms_size = EXTMEM_SIZE >> 10;
   x_printf("XMS: initializing XMS... %d handles\n", NUM_HANDLES);
 
   freeHMA = (config.hma && !ext_hooked_hma);
@@ -279,17 +316,14 @@ static int xms_helper_init(void)
 
   if (!config.xms_size)
     return 0;
-  xms_base = ext_mem_base;  // TODO!
   handle_count = 0;
   for (i = 0; i < NUM_HANDLES; i++) {
     if (handles[i].valid && handles[i].addr)
-      xms_free(handles[i].addr);
+      xms_free(handles[i].addr, handles[i].size);
     handles[i].valid = 0;
   }
-
-  smdestroy(&mp);
-  sminit(&mp, xms_base, config.xms_size * 1024);
-  smregister_error_notifier(&mp, xx_printf);
+  totalBytes = 0;
+  intdrv = 1;
   return 1;
 }
 
@@ -640,10 +674,9 @@ ValidHandle(unsigned short h)
 static unsigned char
 xms_query_freemem(int api)
 {
-  unsigned totalBytes = 0, subtotal, largest;
-  int h;
+  unsigned subtotal, largest;
 
-  if (!config.xms_size) {
+  if (!intdrv) {
     if (api == OLDXMS) {
       LWORD(eax) = 0;
       LWORD(edx) = 0;
@@ -662,19 +695,10 @@ xms_query_freemem(int api)
   if (api == NEWXMS)
     x_printf("XMS: new XMS API query_freemem()!\n");
 
-  /* total XMS mem and largest block can be different because of
-   *  fragmentation
-   */
-
-  totalBytes = 0;
-  for (h = FIRST_HANDLE; h < NUM_HANDLES; h++) {
-    if (ValidHandle(h))
-      totalBytes += PAGE_ALIGN(handles[h].size);
-  }
   /* xms_size is page-aligned in config.c */
   subtotal = config.xms_size - (totalBytes / 1024);
   /* total free is max allowable XMS - the number of K already allocated */
-  largest = (smget_largest_free_area(&mp) & PAGE_MASK) / 1024;
+  largest = subtotal;
 
   if (api == OLDXMS) {
     /* old XMS API uses only AX, while new API uses EAX. make
@@ -709,10 +733,10 @@ static unsigned char
 xms_allocate_EMB(int api)
 {
   unsigned int h;
-  unsigned int kbsize;
-  unsigned addr;
+  unsigned int kbsize, size;
+  void *addr;
 
-  if (!config.xms_size)
+  if (!intdrv)
     return 0xa0;
 
   if (api == OLDXMS)
@@ -725,19 +749,21 @@ xms_allocate_EMB(int api)
     x_printf("XMS: out of handles\n");
     return 0xa1;
   }
-  if (kbsize == 0) {
-    x_printf("XMS WARNING: allocating 0 size EMB\n");
-    addr = 0;
+  size = kbsize * 1024;
+  if (kbsize == 0 || totalBytes + size > config.xms_size * 1024) {
+    error("XMS WARNING: allocating 0 size EMB\n");
+    return 0xa0;
   } else {
-    addr = xms_alloc(kbsize*1024);
+    addr = xms_alloc(size);
     if (!addr) {
       x_printf("XMS: out of memory\n");
       return 0xa0; /* Out of memory */
     }
+    totalBytes += size;
   }
   handles[h].num = h;
   handles[h].valid = 1;
-  handles[h].size = kbsize*1024;
+  handles[h].size = size;
   handles[h].addr = addr;
 
   x_printf("XMS: EMB size %d bytes\n", handles[h].size);
@@ -750,7 +776,7 @@ xms_allocate_EMB(int api)
   handles[h].lockcount = 0;
   handle_count++;
 
-  x_printf("XMS: allocated EMB %u at %#x\n", h, handles[h].addr);
+  x_printf("XMS: allocated EMB %u at %p\n", h, handles[h].addr);
 
   if (api == OLDXMS)
     LWORD(edx) = h;		/* handle # */
@@ -769,9 +795,10 @@ xms_free_EMB(void)
     return 0xa2;
   }
   else {
-
-    if (handles[h].addr)
-      xms_free(handles[h].addr);
+    if (handles[h].addr) {
+      totalBytes -= handles[h].size;
+      xms_free(handles[h].addr, handles[h].size);
+    }
     else
       x_printf("XMS WARNING: freeing handle w/no address, size 0x%08x\n",
 	       handles[h].size);
@@ -805,12 +832,11 @@ xms_move_EMB(void)
       x_printf("XMS: invalid source handle\n");
       return 0xa3;
     }
-    src = handles[e.SourceHandle].addr + e.SourceOffset;
-    if (src > handles[e.SourceHandle].addr + handles[e.SourceHandle].size)
+    if (e.SourceOffset > handles[e.SourceHandle].size)
       return 0xa4;              /* invalid source offset */
-    if (src + e.Length > handles[e.SourceHandle].addr + handles[e.SourceHandle].size)
+    if (e.SourceOffset + e.Length > handles[e.SourceHandle].size)
       return 0xa7;              /* invalid Length */
-    s = xms_base + src;
+    s = handles[e.SourceHandle].addr + e.SourceOffset;
   }
 
   if (e.DestHandle == 0) {
@@ -824,17 +850,16 @@ xms_move_EMB(void)
       x_printf("XMS: invalid dest handle\n");
       return 0xa5;
     }
-    dest = handles[e.DestHandle].addr + e.DestOffset;
-    if (dest > handles[e.DestHandle].addr + handles[e.DestHandle].size)
+    if (e.DestOffset > handles[e.DestHandle].size)
       return 0xa6;              /* invalid dest offset */
-    if (dest + e.Length > handles[e.DestHandle].addr + handles[e.DestHandle].size) {
+    if (e.DestOffset + e.Length > handles[e.DestHandle].size) {
       return 0xa7;		/* invalid Length */
     }
-    d = xms_base + dest;
+    d = handles[e.DestHandle].addr + e.DestOffset;
   }
 
-  x_printf("XMS: block move from %#x to %#x len 0x%x\n",
-	   src, dest, e.Length);
+  x_printf("XMS: block move from %p to %p len 0x%x\n",
+	   s, d, e.Length);
   memcpy(d, s, e.Length);
   x_printf("XMS: block move done\n");
 
@@ -845,7 +870,7 @@ static unsigned char
 xms_lock_EMB(int flag)
 {
   int h = LWORD(edx);
-  unsigned addr;
+  dosaddr_t addr;
 
   if (flag)
     x_printf("XMS lock EMB %d\n", h);
@@ -857,15 +882,22 @@ xms_lock_EMB(int flag)
 
     if (flag)
       handles[h].lockcount++;
-    else
+    else {
       if (handles[h].lockcount)
         handles[h].lockcount--;
       else {
         x_printf("XMS: Unlock handle %d already at 0\n", h);
         return 0xaa;		/* Block is not locked */
       }
+      if (!handles[h].lockcount) {
+        unmap_EMB(handles[h].dst, handles[h].size);
+        handles[h].dst = 0;
+      }
+      return 0;
+    }
 
-    addr = handles[h].addr;
+    addr = map_EMB(handles[h].addr, handles[h].size);
+    handles[h].dst = addr;
     LWORD(edx) = addr >> 16;
     LWORD(ebx) = addr & 0xffff;
     return 0;
@@ -905,7 +937,8 @@ static unsigned char
 xms_realloc_EMB(int api)
 {
   int h;
-  unsigned int newaddr, newsize;
+  unsigned int newsize;
+  void *newaddr;
 
   h = LWORD(edx);
 
@@ -932,7 +965,7 @@ xms_realloc_EMB(int api)
   x_printf("XMS realloc EMB(%s) %d to size 0x%04x\n",
 	   api == OLDXMS ? "old" : "new", h, newsize);
 
-  newaddr = xms_realloc(handles[h].addr, newsize);
+  newaddr = xms_realloc(handles[h].addr, handles[h].size, newsize);
   if (!newaddr) {
     x_printf("XMS: out of memory on realloc\n");
     return 0xa0; /* Out of memory */
diff --git a/src/include/emu.h b/src/include/emu.h
index 5c8d0629b9..b0be1e7cec 100644
--- a/src/include/emu.h
+++ b/src/include/emu.h
@@ -517,5 +517,6 @@ extern int hlt_unregister_handler_vm86(Bit16u start_addr);
 extern const char *Path_cdrom[];
 
 extern struct mempool main_pool;
+extern struct mempool lin_pool;
 
 #endif /* EMU_H */
diff --git a/src/include/hma.h b/src/include/hma.h
index 3e4afeded7..dbd109a37d 100644
--- a/src/include/hma.h
+++ b/src/include/hma.h
@@ -8,7 +8,6 @@
 #define __HMA_H
 
 extern int a20;
-extern unsigned char *ext_mem_base;
 void set_a20(int);
 void extmem_copy(unsigned dst, unsigned src, unsigned len);
 
diff --git a/src/include/memory.h b/src/include/memory.h
index f007e8522b..fd38da1264 100644
--- a/src/include/memory.h
+++ b/src/include/memory.h
@@ -184,6 +184,7 @@ void *physaddr_to_unixaddr(dosaddr_t addr);
    give NULL pointer protection.
 */
 extern unsigned char *mem_base;
+#define ext_mem_base (mem_base + LOWMEM_SIZE + HMASIZE)
 
 #define LINP(a) ((unsigned char *)(uintptr_t)(a))
 unsigned char *MEM_BASE32(dosaddr_t a);
diff --git a/src/include/xms.h b/src/include/xms.h
index 4813a1a357..da55d52572 100644
--- a/src/include/xms.h
+++ b/src/include/xms.h
@@ -29,27 +29,6 @@
 #define NEWXMS          2
 
 #ifndef __ASSEMBLER__
-struct __attribute__ ((__packed__)) EMM {
-   unsigned int Length;
-   unsigned short SourceHandle;
-   unsigned int SourceOffset;
-   unsigned short DestHandle;
-   unsigned int DestOffset;
-} ;
-
-struct Handle {
-  unsigned short int num;
-  unsigned int addr;
-  unsigned int size;
-  int valid;
-  int lockcount;
-};
-
-struct UMB {
-  unsigned short segment, size;
-  int used;
-};
-
 void xms_init(void);
 void xms_reset(void);
 void xms_helper(void);
